import { Global } from "../Global";
import GameTipDraw from "../GameScene/GameTipDraw";

const {ccclass, property} = cc._decorator;

@ccclass
export default class AloneGameUI extends cc.Component {

    @property(cc.Node)
    private btn_tips:cc.Node = null;

    @property(cc.Label)
    private passNumber:cc.Label = null;

    @property(GameTipDraw)
    private gameTipDraw:GameTipDraw = null;

    onLoad(){
        this.btn_tips.on(cc.Node.EventType.TOUCH_START, this.openTipUI, this);                

        if(Global.getConfig2){
            if(Global.getConfig2.videoTip == 1 || Global.getConfig2.shareTip == 1){
                this.btn_tips.active = true;
            }
            else{
                this.btn_tips.active = false;
            }
        }
    }

    private openTipUI(){        
        this.gameTipDraw.node.active = true;
    }

    public updatePass(){
        this.passNumber.string = `第${Global.curPassIndex + 1}关`;
    }

}
