import ShowAlonePass from "./ShowAlonePass";
import { Global } from "../Global";
import { Const } from "../Const";

const {ccclass, property} = cc._decorator;

let self:AloneUI;
@ccclass
export default class AloneUI extends cc.Component {
    
    @property(cc.Node)
    private passDataContent = null;

    @property(cc.Node)
    private enterPassTipUI:cc.Node = null;

    @property(cc.Prefab)
    private showAlonePass:cc.Node = null;

    private btn_back:cc.Node = null;

    private passDataArray = [];

    onLoad(){
        let width = cc.director.getScene().getChildByName("Canvas").width;
        if (width < 720) {                        
            this.node.setScale(width / 720);
        }
    }

    onEnable(){        
        self = this;

        self.btn_back = self.node.getChildByName("btn_back");

        self.passDataArray = self.passDataContent.children;          

        let startIndex = 1;
        let endIndex = 6;

        for(let i = 0; i < 8; i++){
            let obj = cc.instantiate(self.showAlonePass);
            obj.parent = self.passDataContent;
        }

        for(let i = 0; i < self.passDataArray.length; i++){            
            self.passDataArray[i].getComponent(ShowAlonePass).setData(startIndex, endIndex);
            startIndex += 6;
            endIndex += 6;
        }
        
        self.btn_back.on(cc.Node.EventType.TOUCH_START, self.backHall, self);

        Global.gameType = Const.aloneGame;
    }

    onDisable(){
        self.passDataContent.destroyAllChildren();
        self.enterPassTipUI.active = false;
    }

    private backHall(){
        self.node.active = false;
        Global.gameType = Const.passGame;
    }



}
