import { wxApply } from "../wxGame/wxApply";
import { Global } from "../Global";

const {ccclass, property} = cc._decorator;

@ccclass
export default class EnterPassTipUI extends cc.Component {

    @property(cc.Node)
    private btn_invite:cc.Node = null;

    @property(cc.Node)
    private btn_start:cc.Node = null;

    @property(cc.Label)
    private passNumber:cc.Label = null;

    private isClick = true;

    private curIndex;

    onLoad(){
        this.btn_invite.on(cc.Node.EventType.TOUCH_START, this.share, this);
        this.btn_start.on(cc.Node.EventType.TOUCH_END, this.startGame, this);
    }

    private share(){
        wxApply.shareAppMessage(1);
    }

    public setInfo(num){        
        this.curIndex = parseInt(num);
        this.passNumber.string = `第${num}关`;
    }

    private startGame(){        
        if(!this.isClick){
            return
        }
        else{
            this.isClick = false;
            setTimeout(()=>{
                this.isClick = true;
            },1000)
        }

        Global.curPassIndex = this.curIndex - 1;        
        cc.director.emit("gameStart");
        cc.director.emit("hideGamehall");

        setTimeout(()=>{
            cc.director.emit("againGame", {
                isSave: false
            });             

            this.node.parent.active = false;        
            Global.aloneUI.active = false;
            this.node.active = false;
        }, 400)  
    }

}
