import { Global } from "../Global";
import { wxApply } from "../wxGame/wxApply";
import { Const } from "../Const";

const { ccclass, property } = cc._decorator;

let self: GameHallScene
@ccclass
export default class GameHallScene extends cc.Component {

    private btn_setting: cc.Node;
    private settingUI: cc.Node;

    private btn_shop: cc.Node;
    private shopUI: cc.Node;

    private btn_goldPrize: cc.Toggle;
    private prizeTimer: cc.Label;

    ///|private btn_rank: cc.Node;

    private btn_another: cc.Node;
    private btn_anotherQQ:cc.Node;
    private btn_moregame: cc.Node;

    private btn_openAlone:cc.Node;             //闯关模式

    @property(cc.Node)
    private aloneUI:cc.Node = null;            //闯关模式UI

    @property(cc.Node)
    private newGuide:cc.Node = null;

    @property(cc.Node)
    private tip_buyShop: cc.Node = null;

    onLoad() {
        self = this;
        let bottomGroup = self.node.getChildByName("bottonGroup");

        self.btn_setting = bottomGroup.getChildByName("btn_setting");
        self.settingUI = self.node.getChildByName("settingUI");

        self.btn_shop = bottomGroup.getChildByName("btn_shop");
        self.shopUI = self.node.getChildByName("shopUI");

        self.btn_another = self.node.getChildByName("btn_another");
        self.btn_anotherQQ = self.node.getChildByName("btn_anotherQQ");
        self.btn_moregame = self.node.getChildByName("btn_moregame");

        self.btn_goldPrize = bottomGroup.getChildByName("btn_goldPrize").getComponent(cc.Toggle);
        self.prizeTimer = bottomGroup.getChildByName("btn_goldPrize").getChildByName("Background").getChildByName("timer").getComponent(cc.Label);

        ///|self.btn_rank = bottomGroup.getChildByName("btn_rank");

        self.btn_openAlone = self.node.getChildByName("btn_openAlone");      
        
        //let ganTan = self.btn_openAlone.getChildByName("")

        self.addEvent();
    }

    start() {

    }

    onDisable() {
        self.node.opacity = 255;
        //self.unschedule(self.updatePrizeTimer);

        if(Global.getConfig1){
            Global.hideBanner();
        }        
    }

    onEnable() {
        //self.judgeGoldPrizeTimer()
        if(Global.getConfig1){
            Global.creatBanner("adunit-b8348ac00ef550cb");
        }     

        Global.gameType = Const.passGame;      
        console.log("回来");
    }

    private addEvent() {
        cc.director.on("hideGamehall", self.hideMy, self);
        cc.director.on("initSdkComplete", self.initSdkComplete, self);
        cc.director.on("readComplete", self.judgeGoldPrizeTimer, self);
        cc.director.on("gameInit", self.gameInit, self);
        cc.director.on("shopping", self.shopping, self);

        self.btn_setting.on(cc.Node.EventType.TOUCH_END, self.openSettingUI, self);
        self.btn_shop.on(cc.Node.EventType.TOUCH_END, self.openShopUI, self);
        ///|self.btn_rank.on(cc.Node.EventType.TOUCH_END, self.openRankUI, self);

        self.btn_another.on(cc.Node.EventType.TOUCH_END, self.openAnother, self);
        self.btn_anotherQQ.on(cc.Node.EventType.TOUCH_END, self.openQQGame, self);
        self.btn_moregame.on(cc.Node.EventType.TOUCH_END, self.openMoregame, self);
        self.btn_openAlone.on(cc.Node.EventType.TOUCH_END, self.openAloneUI, self);
    }

    private openQQGame(){
        Global.sdkQQ.jumpToCurrentGame();
    }

    private initSdkComplete(){
        if(Global.getConfig1.hz2 == 0){
            self.btn_another.active = false;
        }
        else{
            let anotherInfo = Global.getConfig1.hz2_d;        

            if (anotherInfo.imageUrl) {  
                sdk.createImage(self.btn_another.getComponent(cc.Sprite), anotherInfo.imageUrl);                      
            }
    
            self.btn_another.active = true;
        }

        if(Global.getConfig1.hz3 == 0){
            self.btn_moregame.active = false;
        }
        else{            
            let moregameInfo = Global.getConfig1.hz3_d;

            if (moregameInfo.imageUrl) {  
                sdk.createImage(self.btn_moregame.getComponent(cc.Sprite), moregameInfo.imageUrl);                      
            }

            self.btn_moregame.active = true;
        }           
        
        Global.creatBanner("adunit-b8348ac00ef550cb");
    }

    private openAloneUI(){
        self.aloneUI.active = true;
    }

    private openSettingUI() {
        Global.playMusic("ball_collide");
        self.settingUI.active = true;
    }

    private openShopUI() {
        Global.playMusic("ball_collide");
        self.shopUI.active = true;
    }

    private openRankUI() {
        Global.playMusic("ball_collide");
        let msg = {
            message: "friend",
            nickname: Global.USER_INFO.nickname
        }
        wxApply.postMessage(msg);
        ///|Global.rankUI.showMy(1);
    }

    private gameInit(){
        self.tipBuyShop();
    }

    private shopping(){
        self.tip_buyShop.active = false;
    }
    
    public tipBuyShop(){
        if(Global.USER_INFO.newPlayer){     //如果是新玩家            
            if(!self.tip_buyShop.active){
                self.tip_buyShop.active = true;
                self.tip_buyShop.runAction(cc.repeatForever(
                    cc.sequence(
                        cc.moveBy(0.3, -20, 20),
                        cc.moveBy(0.3, 20, -20)
                    )
                ))
            }
        }
        else{
            self.tip_buyShop.active = false;
        }
    }

    private openGoldPrize() {
        Global.USER_INFO.curTimer = new Date().getTime();
        Global.addGold(80);
        Global.setToast("获得80钻石");

        self.btn_goldPrize.interactable = false;

        self.judgeGoldPrizeTimer();
    }

    private judgeGoldPrizeTimer() {
        if (!Global.judgeOnTimer()) {
            self.btn_goldPrize.interactable = false;
            self.btn_goldPrize.isChecked = false;
            self.schedule(self.updatePrizeTimer, 1);
        }

        if (Global.USER_INFO.isOpenNewGuide){
            this.newGuide.active = true
        }
    }

    private updatePrizeTimer() {
        let cur = new Date().getTime();

        let pad = (Global.USER_INFO.curTimer + 10800000 - cur);        

        self.prizeTimer.string = self.formatSeconds(Math.floor(pad / 1000));

        if (Global.judgeOnTimer()) {
            self.btn_goldPrize.interactable = true;
            self.btn_goldPrize.isChecked = true;
            self.unschedule(self.updatePrizeTimer);
        }
    }


    private formatSeconds(value) {
        var secondTime = value;// 秒
        var minuteTime = 0;  // 分
        var hourTime = 0;    // 小时
        if (secondTime > 60) {//如果秒数大于60，将秒数转换成整数
            //获取分钟，除以60取整数，得到整数分钟
            minuteTime = secondTime / 60;
            //获取秒数，秒数取佘，得到整数秒数
            secondTime = secondTime % 60;
            //如果分钟大于60，将分钟转换成小时
            if (minuteTime > 60) {
                //获取小时，获取分钟除以60，得到整数小时
                hourTime = minuteTime / 60;
                //获取小时后取佘的分，获取分钟除以60取佘的分
                minuteTime = minuteTime % 60;
            }
        }
        var result = Math.floor(secondTime) + "";

        if(secondTime > 0){
            if(secondTime < 10){
                result = "0" + Math.floor(secondTime);
            }
        }

        if (minuteTime > 0) {
            if(minuteTime < 10){
                result = "0" + Math.floor(minuteTime) + ":" + result;
            }
            else{
                result = Math.floor(minuteTime) + ":" + result;
            }            
        }

        if (hourTime > 0) {
            result = Math.floor(hourTime) + ":" + result;
        }
        
        return result;
    }

    private openAnother() {
        let anotherInfo = Global.getConfig1.hz2_d;
        wxApply.navigateToMiniProgram(anotherInfo.appId, anotherInfo.path, anotherInfo.extraData, anotherInfo.envVersion);
    }

    private openMoregame() {
        let moreGameInfo = Global.getConfig1.hz3_d;
        wxApply.navigateToMiniProgram(moreGameInfo.appId, moreGameInfo.path, moreGameInfo.extraData, moreGameInfo.envVersion);
    }

    private hideMy() {
        if(Global.gameType == Const.passGame){
            var callBack = cc.callFunc(() => {
                self.node.active = false;
            })
            self.node.runAction(cc.sequence(
                cc.fadeOut(1),
                callBack
            ))
        }
        else{
            self.node.active = false;
        }
    }
}
