import { wxApply } from "../wxGame/wxApply";
import { Global } from "../Global";

const {ccclass, property} = cc._decorator;

let self:PopShareUI
@ccclass
export default class PopShareUI extends cc.Component {
    
    private btn_share:cc.Node;

    @property(cc.Sprite)
    private mySprite:cc.Sprite = null;

    onLoad(){
        self = this;
        self.btn_share = self.node.getChildByName("btn_share");

        self.btn_share.on(cc.Node.EventType.TOUCH_END, self.sharePrize, self);
        
        if (Global.getConfig2) {
            if (Global.getConfig2.shareGoldSwtich == 0) {
                self.btn_share.active = false;
            }
        }
    }

    onEnable(){        
        self.node.opacity = 0;
        self.node.runAction(cc.fadeIn(0.5));
        cc.loader.loadRes(`Image/Ball/ball_${Global.USER_INFO.selectBall}`, cc.SpriteFrame, function (err, data) {
            if (err) {
                console.error("读取篮球图片失败");
            }
            else {                                
                self.mySprite.spriteFrame = data;                
            }
        })          
    }

    /**
     * 
     * @param type 1.球  2线
     */
    public setMySprite(type){
        if(type == 1){
            cc.loader.loadRes(`Image/Ball/ball_${Global.USER_INFO.selectBall}`, cc.SpriteFrame, function (err, data) {
                if (err) {
                    console.error("读取篮球图片失败");
                }
                else {                                
                    self.mySprite.spriteFrame = data;                
                }
            }) 
        }
        else{
            cc.loader.loadRes(`Image/Line/line_${Global.USER_INFO.selectLine}`, cc.SpriteFrame, function (err, data) {
                if (err) {
                    console.error("读取篮球图片失败");
                }
                else {                                
                    self.mySprite.spriteFrame = data;                
                }
            }) 
        }
    }

    private sharePrize(){
        wxApply.shareAppMessage(3, 50);
        self.node.active = false;
    }

}
