import { Global } from "../Global";
import { Const } from "../Const";

const { ccclass, property } = cc._decorator;

@ccclass
export default class BasketLogic extends cc.Component {

    private hideEffect: sp.Skeleton;
    private prizeEffect: sp.Skeleton;

    private type = 0;

    private prizeGold:cc.Node;

    onLoad() {
        var self = this;
        self.hideEffect = self.node.getChildByName("hideEffect").getComponent(sp.Skeleton);
        self.prizeEffect = self.node.getChildByName("prizeEffect").getComponent(sp.Skeleton);

        self.prizeGold = self.node.getChildByName("prizeGold");        
    }

    onEnable(){
        let random = Math.random();
        if(random < 0.3){
            this.prizeGold.active = true;
        }
    }

    onDisable(){
        this.type = 0;
    }    

    public showHideEffect() {        
        this.hideEffect.animation = "await2";
        this.hideEffect.node.active = true;                      
        this.scheduleOnce(()=>{
            this.hideEffect.node.active = false;
        }, 0.5)  
    }

    public showPrizeEffect() {        
        this.prizeEffect.animation = "await7";
        this.prizeEffect.node.active = true;                      
        this.scheduleOnce(()=>{
            this.prizeEffect.node.active = false;
        }, 0.3)  
    }

    public backHome() {                
        if(this.type == Const.basketLeftID){
            this.node.parent = Global.basketParentLeft;            
        }
        else if(this.type == Const.basketRightID){
            this.node.parent = Global.basketParentRight;
        }
        else if(this.type == Const.nobasketID){
            this.node.parent = Global.nobasketBall;
        }
                
        this.node.active = false;
    }

    public setType(type){
        this.type = type;
    }

}
