import { wxApply } from "../wxGame/wxApply";
import { Global } from "../Global";
import { Const } from "../Const";
import GameTipDraw from "./GameTipDraw";

const { ccclass, property } = cc._decorator;

let self: GameOverUI
@ccclass
export default class GameOverUI extends cc.Component {

    //gameOver1场景
    private gameOver1: cc.Node;
    private btn_videoFuhuo: cc.Node;
    private btn_shareFuhuo: cc.Node;
    private btn_tiaoGuo: cc.Node;
    private myScoreOver1: cc.Label;

    //gameOver2场景
    private gameOver2: cc.Node;
    private btn_videoPrize: cc.Node;
    private btn_again: cc.Node;
    ///|private btn_rank: cc.Node;
    private btn_share: cc.Node;
    private myScoreOver2: cc.Label;
    private maxScore: cc.Label;
    private btn_goHome2: cc.Node;
    private passOverLable: cc.Node;

    private AloneOverLable: cc.Node;
    private curPassNumber: cc.Label;
    private btn_nextGame: cc.Node;

    @property(GameTipDraw)
    private gameTipDraw: GameTipDraw = null;

    @property(cc.Label)
    private passTip = null;

    @property(cc.Node)
    private yanHua = null;

    @property(cc.Node)
    private btn_xuexixiaotu = null;

    @property(cc.Node)
    private btn_tishi = null;

    onLoad() {
        self = this;

        //gameOver1组件
        self.gameOver1 = self.node.getChildByName("gameOver1");
        self.btn_videoFuhuo = self.gameOver1.getChildByName("btn_videoFuhuo");
        self.btn_shareFuhuo = self.gameOver1.getChildByName("btn_shareFuhuo");
        self.btn_tiaoGuo = self.gameOver1.getChildByName("btn_tiaoGuo");
        self.myScoreOver1 = self.gameOver1.getChildByName("myScoreOver1").getComponent(cc.Label);

        //gameOver2组件        
        self.gameOver2 = self.node.getChildByName("gameOver2");

        self.btn_videoPrize = self.gameOver2.getChildByName("btn_videoPrize");
        self.btn_again = self.gameOver2.getChildByName("btn_again");
        ///|self.btn_rank = self.gameOver2.getChildByName("btn_rank");
        self.btn_share = self.gameOver2.getChildByName("btn_share");
        self.passOverLable = self.gameOver2.getChildByName("passOverLable");
        self.myScoreOver2 = self.passOverLable.getChildByName("myScoreOver2").getComponent(cc.Label);
        self.maxScore = self.passOverLable.getChildByName("maxScore").getComponent(cc.Label);
        self.btn_goHome2 = self.gameOver2.getChildByName("btn_goHome2");
        self.btn_nextGame = self.gameOver2.getChildByName("btn_nextGame");

        self.AloneOverLable = self.gameOver2.getChildByName("AloneOverLable");
        self.curPassNumber = self.AloneOverLable.getChildByName("curPassNumber").getComponent(cc.Label);

        self.addEvent();
    }

    start() {

    }

    onEnable() {
        if (Global.getConfig1) {
            if (Global.getConfig1.fs == 0) {
                self.btn_videoFuhuo.active = false;
            }

            if (Global.getConfig1.hz == 0) {
                self.btn_shareFuhuo.active = false;
            }
            else {
                if (Global.getConfig1.fs == 0) {
                    self.btn_shareFuhuo.x = 0;
                }
            }
        }

        if (Global.getConfig2) {
            if (Global.getConfig2.videoGoldSwitch == 0) {
                self.btn_videoPrize.active = false;
            }
            else {
                self.btn_videoPrize.active = true;
            }

            if (Global.getConfig2.shareGoldSwtich == 0) {
                self.btn_share.active = false;
            }
            else {
                self.btn_share.active = true;
            }

            if (Global.getConfig2.shareTip == 0) {
                self.btn_tishi.active = false;
            }
            else {
                self.btn_tishi.active = true;
            }
        }


        if (Global.gameType == Const.passGame) {
            self.passOverLable.active = true;
            self.AloneOverLable.active = false;
            self.btn_tishi.active = false;

            self.myScoreOver1.string = Global.curScore + "";
            self.myScoreOver2.string = Global.curScore + "";

            if (Global.curScore > Global.USER_INFO.maxScore) {
                Global.USER_INFO.maxScore = Global.curScore;
            }
            self.maxScore.string = Global.USER_INFO.maxScore + "";

            if (Global.fuhuoCount == 0) {
                let msg = {
                    message: "nextPlayer",
                    nickname: Global.USER_INFO.nickname,
                    myScore: Global.curScore
                }
                wxApply.postMessage(msg);

                self.scheduleOnce(() => {
                    ///|Global.rankUI.showMy(2);
                }, 0.5);

                self.btn_tiaoGuo.active = false;
                self.scheduleOnce(() => {
                    self.btn_tiaoGuo.active = true;
                }, 2)

                self.gameOver1.active = true;
            }
            else {
                self.gameOver2.active = true;
            }
            self.btn_xuexixiaotu.active = true;
            self.btn_again.active = true;
            //self.btn_rank.active = true;
            self.btn_nextGame.active = false;
            self.btn_again.x = 91;
            self.btn_share.x = -88;
        }
        else {
            self.passOverLable.active = false;
            self.AloneOverLable.active = true;

            if (Global.isGameStart) {
                self.btn_nextGame.active = true;
                self.btn_again.active = false;

                Global.updateAlone(Global.curPassIndex + 2);

                self.passTip.string = "恭喜过关";
                self.yanHua.active = true;
                self.btn_nextGame.x = 15;
            }
            else {
                self.btn_nextGame.active = false;
                self.btn_again.active = true;
                self.passTip.string = "挑战失败";
                self.btn_again.x = 15;
            }
            self.curPassNumber.string = `第${Global.curPassIndex + 1}关`;
            self.gameOver2.active = true;

            if(Global.getConfig2){
                if (Global.getConfig2.shareTip != 0) {
                    self.btn_tishi.active = true;
                } 
            }           

            
            self.btn_share.x = -158;
        }


        self.node.opacity = 0;
        self.node.runAction(cc.fadeIn(0.5));
        cc.director.emit("stopTimer");
    }

    onDisable() {
        self.gameOver1.active = false;
        self.gameOver2.active = false;
        self.yanHua.active = false;
        self.btn_xuexixiaotu.active = false;
    }

    private addEvent() {
        //gameOver1监听
        self.btn_videoFuhuo.on(cc.Node.EventType.TOUCH_END, self.videoFuhuo, self);
        self.btn_shareFuhuo.on(cc.Node.EventType.TOUCH_END, self.shareFuhuo, self);
        self.btn_tiaoGuo.on(cc.Node.EventType.TOUCH_END, self.tiaoGuo, self);

        //gameOver2监听
        self.btn_videoPrize.on(cc.Node.EventType.TOUCH_END, self.videoPrize, self);
        self.btn_again.on(cc.Node.EventType.TOUCH_END, self.again, self);
        ///|self.btn_rank.on(cc.Node.EventType.TOUCH_END, self.openRank, self);
        self.btn_share.on(cc.Node.EventType.TOUCH_END, self.share, self);
        self.btn_goHome2.on(cc.Node.EventType.TOUCH_END, self.backHall, self);
        self.btn_nextGame.on(cc.Node.EventType.TOUCH_END, self.nextGame, self);
        self.btn_xuexixiaotu.on(cc.Node.EventType.TOUCH_END, self.openAloneUI, self);
        self.btn_tishi.on(cc.Node.EventType.TOUCH_END, self.openTipUI, self);

        cc.director.on("tipMode", self.closeMy, self);
    }

    private nextGame() {
        Global.curPassIndex++;
        cc.director.emit("againGame", {
            isSave: false
        })
        self.node.active = false;
    }

    private videoFuhuo() {
        Global.createRewardedVideoAd("adunit-b38863c17f25ef30", self.fuhuo)
    }

    private fuhuo() {
        Global.fuhuoCount++;

        cc.director.emit("againGame", {
            isSave: true
        })
    }

    private prizeGold() {
        Global.addGold(25);
        self.btn_videoPrize.active = false;
    }

    private videoPrize() {
        Global.createRewardedVideoAd("adunit-b38863c17f25ef30", self.prizeGold);
    }

    private shareFuhuo() {
        if (Global.getConfig1.fs == 0) {
            self.btn_videoPrize.active = false;
        }
        wxApply.shareAppMessage(2);
    }

    private again() {
        // cc.director.emit("againGame", {
        //     isSave:false
        // })
        // self.node.active = false;


        if (Global.gameType == Const.passGame) {
            self.backHall();
        }
        else {
            cc.director.emit("againGame", {
                isSave: false
            })
            self.node.active = false;
        }
    }

    private backHall() {
        if (Global.gameType == Const.passGame) {
            self.scheduleOnce(() => {
                self.node.active = false;
                Global.isGameStart = false;

                cc.director.emit("gameInit");
            }, 0.2)
        }
        else {
            self.scheduleOnce(() => {
                self.node.active = false;
                Global.isGameStart = false;

                cc.director.emit("gameInit");
            }, 0.2)
            // cc.director.emit("againGame", {
            //     isSave: false
            // })
            // self.node.active = false;
        }
    }

    private openRank() {
        let msg = {
            message: "friend",
            nickname: Global.USER_INFO.nickname
        }
        wxApply.postMessage(msg);
        ///|Global.rankUI.showMy(1);
    }

    private share() {
        wxApply.shareAppMessage(1);
    }

    private tiaoGuo() {
        ///|Global.rankUI.closeMy();

        self.gameOver1.active = false;
        self.gameOver2.active = true;
    }

    private openAloneUI() {
        self.node.active = false;
        Global.isGameStart = false;

        cc.director.emit("gameInit");

        Global.aloneUI.active = true;
    }

    private openTipUI() {
        self.gameTipDraw.node.active = true;
    }

    private closeMy() {
        self.node.active = false;
    }

}
