import { Global } from "../Global";
import { Const } from "../Const";
import BallConLogic from "./BallConLogic";

const { ccclass, property } = cc._decorator;

let self: GamePrefabPool
@ccclass
export default class GamePrefabPool extends cc.Component {
    @property(cc.Node)
    private basketTopParent = null;

    @property(cc.Prefab)
    private basketTopObj = null;

    @property(cc.Node)
    private basketParentLeft = null;

    @property(cc.Prefab)
    private basketLeftObj = null;

    @property(cc.Node)
    private basketParentRight = null;

    @property(cc.Prefab)
    private basketRightObj = null;

    @property(cc.Node)
    private nobasketBall = null;

    @property(cc.Prefab)
    private nobasketObj = null;

    @property(cc.Node)
    private ballParent = null;

    @property(cc.Node)
    private ballObj = null;

    @property(cc.Node)
    private boomPatent = null;

    @property(cc.Prefab)
    private boom = null;

    @property(cc.Node)
    private lumpPatent = null;

    @property(cc.Prefab)
    private lump = null;

    onLoad() {
        self = this;
        Global.basketTopParent = self.basketTopParent;
        Global.basketParentLeft = self.basketParentLeft;
        Global.basketParentRight = self.basketParentRight;
        Global.nobasketBall = self.nobasketBall;
        Global.ballParent = self.ballParent;
        Global.boomParent = self.boomPatent;
        Global.lumpParent = self.lumpPatent;
    }

    /**
 * 
 * @param type 1.球  2.篮框下(左)  3.篮框下(右)  4. 篮框上  5.无篮框  6.炸弹  7.弹力块
 */
    public getObj(type) {
        var obj;
        var pre;
        switch (type) {
            case Const.ballID:
                //obj = this.ballParent.children[0];
                pre = this.ballObj;
                break;
            case Const.basketLeftID:
                obj = this.basketParentLeft.children[0];
                pre = this.basketLeftObj;
                break;
            case Const.basketRightID:
                obj = this.basketParentRight.children[0];
                pre = this.basketRightObj;
                break;
            case Const.basketTopID:
                obj = this.basketTopParent.children[0];
                pre = this.basketTopObj;
                break;
            case Const.nobasketID:
                obj = this.nobasketBall.children[0];                                
                pre = this.nobasketObj;
                break;
            case Const.boomID:
                //obj = this.boomPatent.children[0];
                pre = this.boom;
                break;
            case Const.lumpID:
                //obj = this.lumpPatent.children[0];
                pre = this.lump;
                break;
            default:
                console.error("获取物品参数错误");
                break;
        }
        if (obj) {
            obj.active = true;
            obj.rotation = 0;
            return obj;
        }
        else {                      
            let prefab = cc.instantiate(pre);
            if(type == Const.ballID){
                prefab.getComponent(BallConLogic).addEvent();
            }                        

            //prefab.parent = this.node;
            prefab.rotation = 0;
            return prefab;
        }
    }

}
