import { wxApply } from "../wxGame/wxApply";
import { Global } from "../Global";

const {ccclass, property} = cc._decorator;

@ccclass
export default class GameTipDraw extends cc.Component {

    @property(cc.Node)
    private bg:cc.Node = null;

    @property(cc.Node)
    private btn_chakan1:cc.Node = null;

    @property(cc.Node)
    private btn_chakan2:cc.Node = null;

    @property(cc.Node)
    private aloneTipFrame:cc.Node = null;

    @property(cc.Node)
    private readyTip:cc.Node = null;

    @property(cc.Node)
    private btn_play:cc.Node = null;

    @property(cc.Node)
    private btn_again:cc.Node = null;

    @property(cc.Node)
    private btn_close:cc.Node = null;

    @property(cc.Node)
    private readyOver:cc.Node = null;

    @property(cc.Node)
    private btn_startAlone:cc.Node = null;

    @property(cc.Node)
    private btn_againWatch:cc.Node = null;

    @property(cc.Node)
    private gameOverUI:cc.Node = null;

    @property(cc.Node)
    private tipLable:cc.Node = null;

    @property(cc.Node)
    private exceedTip:cc.Node = null;

    onLoad(){        
        this.btn_chakan1.on(cc.Node.EventType.TOUCH_END, this.chaKan, this);
        this.btn_play.on(cc.Node.EventType.TOUCH_END, this.guanKanTip, this);
        this.btn_close.on(cc.Node.EventType.TOUCH_END, this.closeMy, this);

        this.btn_startAlone.on(cc.Node.EventType.TOUCH_END, this.startAlone, this);
        this.btn_againWatch.on(cc.Node.EventType.TOUCH_END, this.againWatch, this);

        this.btn_chakan1.active = true;

        cc.director.on("tipOver", this.tipOver, this);
    }

    onEnable(){
        cc.director.pause();

        this.aloneTipFrame.active = true;
        this.readyTip.active = false;

        this.tipLable.active = true;
        this.exceedTip.active = false;
    }

    onDisable(){        
        this.aloneTipFrame.active = false;
        this.readyTip.active = false;
        cc.director.resume();

        this.exceedTip.active = false;
    }

    private closeMy(){
        this.node.active = false;
    }

    private chaKan(){        
        wxApply.shareAppMessage(4, 0, this.hideMy, this);  
                         
        //this.guanKanTip();
    }

    private hideMy(){                
        if(Global.curPassIndex + 1 > 40){     
            this.tipLable.active = false;
            this.exceedTip.active = true;       
            return;
        }

        this.aloneTipFrame.active = false;
        this.readyTip.active = true;            
        
        if(this.gameOverUI.active){
            this.gameOverUI.active = false;
        }
    }

    private guanKanTip(){
        if(Global.curPassIndex + 1 > 40){     
            this.tipLable.active = false;
            this.exceedTip.active = true;       
            return;
        }

        cc.director.resume();

        this.node.active = false;
        this.readyOver.active = false;
        
        Global.tipSwitch = true;

        cc.director.emit("stopTimer");
        cc.director.emit("tipMode");
    }

    private againWatch(){
        wxApply.shareAppMessage(4, 0, this.guanKanTip, this); 

        //this.guanKanTip();
    }

    private tipOver(){
        Global.tipSwitch = false;        
        this.readyOver.active = true;
    }

    private startAlone(){
        this.readyOver.active = false;
        cc.director.emit("againGame", {
            isSave: false
        }); 
    }
}
