var PTM_RATIO = cc.PhysicsManager.PTM_RATIO;

/**
 * @class PhysicsPolygonCollider
 * @extends PhysicsCollider
 * @uses Collider.Polygon
 */
var MyPhysicsCollider = cc.Class({
    name: 'MyPhysicsCollider',
    extends: cc.PhysicsCollider,
    mixins: [cc.Collider.Polygon],

    properties: {
        lineWidth: 10,
    },

    editor: {
        menu: CC_EDITOR && 'i18n:MAIN_MENU.component.physics/Collider/MyCollider',
        // inspector: CC_EDITOR && 'packages://inspector/inspectors/comps/physics/points-base-collider.js',
        requireComponent: cc.RigidBody
    },

    _createShape: function (scale) {
        var shapes = [];

        var polys = this.points;

        var offset = this.offset;

        var polyIdx = 0;
        for (var i = 0; i < polys.length - 1; i++) {
            var posBegin = polys[i];
            var posEnd = polys[i+1];
            
            var linelen = cc.pDistance(posBegin, posEnd);
            
            var angle = cc.pToAngle(cc.p(posEnd.x - posBegin.x, posEnd.y - posBegin.y)) - Math.PI / 2;

            var midPos = cc.pMidpoint(posBegin, posEnd);

            var shape = new b2.PolygonShape();

            if (shape) {
                shape.SetAsBox(this.lineWidth / 2 / 32, linelen / 2 / 32, new b2.Vec2(midPos.x / 32, midPos.y / 32), angle);
                shapes.push(shape);
            }
        }

        // if(!shape){
        //     console.log("我是空", shape);
        // }        

        return shapes;
    }
    
});

module.exports = MyPhysicsCollider;
