const { ccclass, property } = cc._decorator;
let talefun = (<any>cc).talefun;
import MyPhysicsCollider = require("./MyPhysicsCollider")
import { Global } from "../../Global";
let self: physicsNodeLogic
@ccclass
export default class physicsNodeLogic extends cc.Component {
    @property(cc.Node)
    private movePlist = null;          //粒子效果

    @property(cc.Node)
    private fingerTip = null;          //手指提示

    @property(cc.Node)
    private maskInput = null;           //遮罩

    //线的粒子
    @property(cc.Prefab)
    private linePlist: cc.Prefab = null;

    @property(cc.Node)
    private linePlistNode: cc.Node = null;

    private linePlistPool: cc.NodePool;           //粒子池

    //创建线
    private path: cc.Graphics = null;
    private points: cc.Vec2[] = [];         //物理引擎的点
    private tempPoints: cc.Vec2[] = [];     //临时点数组        

    private curPhysicsLine = null;


    //参数
    private isMove = false;     //是否移动过
    private isCanMove = true;   //是否可以移动   

    private moveMusicTimer = true;   //是否到移动时间
    private moveTimer = true;

    private isPen = true;       //还有笔吗    

    private isReMoveEvent = false;  //是否移除监听

    onLoad() {
        self = this;

        self.path = self.addComponent(cc.Graphics);
        self.path.strokeColor = cc.hexToColor(Global.USER_INFO.curLineColor);
        self.path.lineWidth = 15;

        self.linePlistPool = new cc.NodePool();
        //let initCount = 20;
        // for (let i = 0; i < initCount; ++i) {
        //     let enemy = cc.instantiate(this.linePlist); // 创建节点
        //     enemy.color = cc.hexToColor(Global.USER_INFO.curLineColor);
        //     this.linePlistPool.put(enemy); // 通过 putInPool 接口放入对象池
        // }

        self.addTouch();

        self.movePlist.color = cc.hexToColor(Global.USER_INFO.curLineColor);


        cc.director.on("gameOver", self.gameOver, self);
        cc.director.on("updateWuPin", self.updateWuPin, self);
        cc.director.on("stopTimer", self.stopTimer, self);
        cc.director.on("tipMode", self.tipMode, self);
    }

    start() {
        // let data = {pos:[[360, 200], [650, 500]], type:1, complerteTime:50, delayTime:100}
        // self.tipDraw(data);

        // let data = [
        //     {pos: [[360, 200], [400, 300], [620, 500]], type: 2, complerteTime: 50, delayTime: 0},
        //     {pos:[[360, 200], [650, 500]], type:1, complerteTime:50, delayTime:1100}
        // ];
        // self.tipPoPArray(data);
    }

    onDestroy() {
        self.removeTouch();
    }

    onDisable() {

    }

    addTouch() {
        self.node.on(cc.Node.EventType.TOUCH_START, self.touchStart, self);
        self.node.on(cc.Node.EventType.TOUCH_MOVE, self.touchMove, self);
        self.node.on(cc.Node.EventType.TOUCH_END, self.touchEnd, self);
        self.node.on(cc.Node.EventType.TOUCH_CANCEL, self.touchCancel, self);
    }

    addMove() {
        self.node.on(cc.Node.EventType.TOUCH_MOVE, self.touchMove, self);
        self.node.on(cc.Node.EventType.TOUCH_END, self.touchEnd, self);
        self.node.on(cc.Node.EventType.TOUCH_CANCEL, self.touchCancel, self);
    }

    removeTouch() {
        self.node.off(cc.Node.EventType.TOUCH_START, self.touchStart, self);
        self.node.off(cc.Node.EventType.TOUCH_MOVE, self.touchMove, self);
        self.node.off(cc.Node.EventType.TOUCH_END, self.touchEnd, self);
        self.node.off(cc.Node.EventType.TOUCH_CANCEL, self.touchCancel, self);
    }

    removeMove() {
        self.node.off(cc.Node.EventType.TOUCH_MOVE, self.touchMove, self);
        self.node.off(cc.Node.EventType.TOUCH_END, self.touchEnd, self);
        self.node.off(cc.Node.EventType.TOUCH_CANCEL, self.touchCancel, self);
    }

    private stopTimer() {
        // if(self.tipTimer){
        //    self.unschedule(self.remainTip);
        // }
    }

    private updateWuPin() {
        self.path.strokeColor = cc.hexToColor(Global.USER_INFO.curLineColor);
        self.movePlist.color = cc.hexToColor(Global.USER_INFO.curLineColor);

        //self.linePlistPool.clear();
    }

    touchStart(event: cc.Event.EventTouch) {
        if (self.isReMoveEvent) {
            console.log("添加监听");
            self.addMove();
            self.isReMoveEvent = false;
        }

        if (!Global.usePen()) {
            self.isPen = false;
            return;
        }
        else {
            self.isPen = true;
        }

        if (!Global.isGameStart) {
            cc.director.emit("hideGamehall");
        }

        self.points = [];
        self.curPhysicsLine = self.addComponent(MyPhysicsCollider);

        let touchLoc = event.getLocation();
        touchLoc = self.node.parent.convertToNodeSpaceAR(touchLoc);

        self.points.push(cc.p(touchLoc.x, touchLoc.y));
        self.tempPoints.push(cc.p(touchLoc.x, touchLoc.y));

        self.path.moveTo(touchLoc.x, touchLoc.y);

        self.isMove = false;

        self.isCanMove = true;

        self.movePlist.setPosition(touchLoc);
        self.movePlist.active = true;
    }

    touchMove(event: cc.Event.EventTouch) {
        if (!self.isPen) {
            return;
        }

        if (!self.isCanMove) {
            //self.touchEnd(null);            
            self.removeMove();
            self.isReMoveEvent = true;
            self.movePlist.active = false;
            console.log("移除监听");
            return;
        }

        if (self.moveTimer) {
            self.moveTimer = false;
            setTimeout(() => {
                self.moveTimer = true;
            }, 50)
        }
        else {
            return;
        }

        if (self.moveMusicTimer) {
            self.moveMusicTimer = false;
            setTimeout(() => {
                self.moveMusicTimer = true;
            }, 100)
            Global.playMusic("move");
        }


        let touchLoc = event.getLocation();
        touchLoc = self.node.parent.convertToNodeSpaceAR(touchLoc);

        // if (Global.stageScale < 0.9) {
        //     //touchLoc.x = touchLoc.x + 320 * (1 - Global.stageScale);
        // }        

        let lastTouchLoc = self.points[self.points.length - 1];

        if (self.checkIsCanDraw(lastTouchLoc, touchLoc)) {
            self.points.push(cc.p(touchLoc.x, touchLoc.y));
            self.tempPoints.push(cc.p(touchLoc.x, touchLoc.y));
            self.path.lineTo(touchLoc.x, touchLoc.y);
            self.path.stroke();
            self.movePlist.setPosition(touchLoc);
        }
        self.createRigibody();
        self.checkMaxDistance();
        self.isMove = true;
    }

    touchEnd(event: cc.Event.EventTouch) {
        if (!self.isPen) {
            return;
        }

        if (Global.curPenCount != 0) {

        }

        if (!Global.isGameStart) {
            cc.director.emit("ballInit")
        }

        self.movePlist.active = false;
        if (!self.isMove) {
            self.path.stroke();
        }
    }

    touchCancel(event: cc.Event.EventTouch) {
        if (!self.isPen) {
            return;
        }

        if (Global.curPenCount != 0) {

        }

        if (!Global.isGameStart) {
            cc.director.emit("ballInit")
        }

        self.movePlist.active = false;
        if (!self.isMove) {
            self.path.stroke();
        }
    }

    checkIsCanDraw(lastPoint: cc.Vec2, nowPoint: cc.Vec2) {
        return cc.pDistance(lastPoint, nowPoint) >= 20;
    }

    private checkMaxDistance() {
        var polys = self.points;

        let dis = 0;
        for (let i = 0; i <= polys.length; i++) {
            let posBegin = polys[i];
            let posEnd = polys[i + 1];

            if (posBegin && posEnd) {
                let linelen = cc.pDistance(posBegin, posEnd);
                dis += linelen;
            }
        }

        if (dis > 600) {
            self.isCanMove = false;

            if (!Global.isGameStart) {
                cc.director.emit("ballInit");
            }
        }
    }

    public getLinePlist() {
        let enemy = null;
        if (this.linePlistPool.size() > 0) { // 通过 size 接口判断对象池中是否有空闲的对象
            enemy = this.linePlistPool.get();
        } else { // 如果没有空闲对象，也就是对象池中备用对象不够时，我们就用 cc.instantiate 重新创建
            enemy = cc.instantiate(this.linePlist);
        }
        enemy.parent = self.linePlistNode; // 将生成的敌人加入节点树 
        enemy.getComponent(sp.Skeleton).animation = "await3"
        enemy.color = cc.hexToColor(Global.USER_INFO.curLineColor);

        return enemy;
    }

    createRigibody() {
        self.curPhysicsLine.lineWidth = self.path.lineWidth;
        self.curPhysicsLine.points = self.points;
        self.curPhysicsLine.apply();
    }

    public clearDraw() {
        if (self.node.active) {
            self.node.active = false;
        }

        self.isCanMove = false;
        for (let i = 0; i < self.tempPoints.length - 1; i++) {
            var node = self.getLinePlist();
            node.setPosition(self.tempPoints[i]);

            if (i == self.tempPoints.length - 2) {
                self.path.clear();
            }
        }
        self.tempPoints = [];
        self.points = [];
        //self.createRigibody();

        self.movePlist.active = false;

        let physicsCollider = self.node.getComponents(MyPhysicsCollider);

        for (let i = 0; i < physicsCollider.length; i++) {
            physicsCollider[i].destroy();
        }

        setTimeout(self.clearLineCd, 500);
        //self.clearLineCd();
    }

    private clearLineCd() {
        self.clearLinePlistArray();
        self.node.active = true;
    }

    private clearLinePlistArray() {
        let linePlist = self.linePlistNode.children;
        for (let i = 0; i < linePlist.length; i++) {
            linePlist[i].destroy();
        }
    }

    private tipMode(){
        // let data = {pos:[[360, 200], [650, 500]], type:1, complerteTime:50, delayTime:100}
        // self.tipDraw(data);

        // let data = [
        //     {pos: [[360, 200], [400, 300], [620, 500]], type: 2, complerteTime: 50, delayTime: 0},
        //     {pos:[[360, 200], [650, 500]], type:1, complerteTime:50, delayTime:1100}
        // ];
        // self.tipPoPArray(data);
        let data = Global.curPassData.tipDraw.slice(0);        
        self.tipPoPArray(data);

        setTimeout(()=>{
            cc.director.emit("openOverTimer");
        }, data[data.length - 1].delayTime);
    }

    private tipPoPArray(data){        
        for(let i = 0; i < data.length; i++){
            setTimeout(()=>{
                self.tipDrawType(data[i]);
            }, data[i].delayTime)
        }
    }

    private tipDrawType(data) {
        self.points = [];
        self.curPhysicsLine = self.addComponent(MyPhysicsCollider);        

        //初始化
        let pos1 = data.pos[0];      //第一个点坐标               
    
        self.points.push(cc.p(pos1[0], pos1[1]));
        self.tempPoints.push(cc.p(pos1[0], pos1[1]));

        self.path.moveTo(pos1[0], pos1[1]);

        self.fingerTip.active = true;          

        if (data.type == 1) {            
            self.twoPintDraw(data.pos, data.complerteTime);
        }
        else {
            let posArray = data.pos;
            let complerteTime = data.complerteTime / (posArray.length - 2);

            for (let i = 0; i < posArray.length - 1; i++) {
                let tempPos;                
                tempPos = [posArray[i], posArray[i + 1]];                             
                self.twoPintDraw(tempPos, complerteTime * i);
            }
        }

        //完成后
        setTimeout(() => {
            self.fingerTip.active = false;
            self.createRigibody();
        }, 20 * data.complerteTime)
    }

    private twoPintDraw(pos, complerteTime) {
        let pos1 = pos[0].slice(0);      //第一个点坐标
        let pos2 = pos[1].slice(0);      //第二个点坐标              

        let padX = (pos2[0] - pos1[0]) / complerteTime;   //相差的X
        let padY = (pos2[1] - pos1[1]) / complerteTime;   //相差的Y        

        for (let i = 0; i < complerteTime; i++) {
            setTimeout(() => {
                pos1[0] = pos1[0] + padX;
                pos1[1] = pos1[1] + padY;

                self.points.push(cc.p(pos1[0], pos1[1]));
                self.tempPoints.push(cc.p(pos1[0], pos1[1]));

                self.path.lineTo(pos1[0], pos1[1]);
                self.path.stroke();

                self.fingerTip.setPosition(cc.v2(pos1[0] + 20, pos1[1] - 50));
            }, 20 * i)
        }
    }


    private gameOver() {
        self.isPen = true;
    }

}
