import { Global } from "../Global";

const {ccclass, property} = cc._decorator;

let self:PauseNode
@ccclass
export default class PauseNode extends cc.Component {

    private btn_home:cc.Node;
    private btn_continue:cc.Node;

    onLoad(){
        self = this;

        self.btn_continue = self.node.getChildByName("btn_continue");
        self.btn_home = self.node.getChildByName("btn_home");

        self.btn_continue.on(cc.Node.EventType.TOUCH_END, self.continue, self);
        self.btn_home.on(cc.Node.EventType.TOUCH_END, self.openBackHome, self);
    }

    onDisable(){
        cc.director.resume();
    }

    private continue(){
        self.node.active = false;        
    }

    private openBackHome(){      
        cc.director.emit("stopTimer");
        cc.director.emit("gameInit");  
        Global.isGameStart = false;
        self.node.active = false;        
    }    


}
