import { Global } from "../Global";

const {ccclass, property} = cc._decorator;

let self:PopEffect
@ccclass
export default class PopEffect extends cc.Component {

    @property(cc.Node)
    private popGood:cc.Node = null;

    @property(cc.Node)
    private popPerfect:cc.Node = null;

    @property(cc.Node)
    private gameOverUI:cc.Node = null;

    onLoad(){
        self = this;                
    }

    /**
     * 
     * @param type 1.很好  2.完美
     */
    public showEffect(type){     
        if(this.gameOverUI.active){
            return;
        }

        var obj:cc.Node;   
        if(type == 1){            
            obj = self.popGood;      
            Global.playMusic("good", 0.7);      
        }
        else if(type == 2){
            obj = self.popPerfect;
            Global.playMusic("perfect", 0.7);
        }

        let cd = cc.callFunc(()=>{                                 
            self.popGood.setScale(0);
            self.popPerfect.setScale(0);
            self.scheduleOnce(()=>{
                obj.active = false;   
            }, 0.2);
        })

        obj.active = true;
                               
        obj.runAction(cc.sequence(
            cc.scaleTo(0.3, 1),
            cc.delayTime(0.15),
            cd
        ))
    }

}
