import { wxApply } from "../wxGame/wxApply";
import { Global } from "../Global";

const {ccclass, property} = cc._decorator;

@ccclass
export default class PopOpenBox extends cc.Component {

    @property(cc.SpriteFrame)
    private shareTypeArray = [];

    private btn_sharePrize:cc.Node;        

    onLoad(){
        this.btn_sharePrize = this.node.getChildByName("btn_sharePrize");
        this.btn_sharePrize.on(cc.Node.EventType.TOUCH_END, this.openShare, this);
    }

    onEnable(){
        // if(Global.getConfig1.fs == 1){
        //     let random = Math.random();
        //     if(random < 0.5){
        //         this.btn_sharePrize.getComponent(cc.Sprite).spriteFrame = this.shareTypeArray[1];                
        //     }
        // }
        this.btn_sharePrize.getComponent(cc.Sprite).spriteFrame = this.shareTypeArray[0];

        this.node.opacity = 0;
        this.node.runAction(cc.fadeIn(0.5));

        Global.stopAllMusic();

        this.scheduleOnce(()=>{
            cc.director.pause();
        }, 0.5); 
    }

    onDisable(){
        cc.director.resume();
    }

    private openShare(){        
        wxApply.shareAppMessage(3, 25, this.closeMy, this);        
    }

    private closeMy(){
        setTimeout(()=>{
            this.node.active = false;
        }, 1000);        
    }
}
