import { Const } from "../Const";

const {ccclass, property} = cc._decorator;

@ccclass
export default class TipMask extends cc.Component {
    @property(cc.SpriteFrame)
    private toolSprite = [];

    onLoad(){
        cc.director.on("stopTimer", this.stopTimer, this);
    }

    onEnable(){
        this.node.runAction(cc.repeatForever(
            cc.sequence(
                cc.fadeOut(0.3),
                cc.fadeIn(0.3)
            )
        ))
    }

    onDisable(){
        this.node.opacity = 255;
    }

    private stopTimer(){
        this.node.active = false;
        this.unscheduleAllCallbacks();
    }

    /**
     * 
     * @param pos 出现位置
     * @param time 出现时间
     * @param type 提示类型     1.球     2.炸弹
     */
    public setShowData(pos, time, type){        
        if(type == Const.ballID){
            this.getComponent(cc.Sprite).spriteFrame = this.toolSprite[0];   
        }        
        else if(type == Const.boomID){
            this.getComponent(cc.Sprite).spriteFrame = this.toolSprite[1];
        }
                        
        this.node.setPositionX(pos[0]);
        this.node.active = true;

        this.scheduleOnce(()=>{
            this.node.active = false;
        }, time)        
    }

}
