import TipMask from "./TipMask";
import { Const } from "../Const";
import { Global } from "../Global";
import Boom from "./Boom";

const { ccclass, property } = cc._decorator;

let self: TipMaskControl
@ccclass
export default class TipMaskControl extends cc.Component {
    private tipArray;

    onLoad() {
        self = this;
        self.tipArray = self.node.children;        
        cc.director.on("stopTimer", self.stopTimer, self);
    }

    private stopTimer(){        
        self.unscheduleAllCallbacks();
    }

    /**
     * 
     * @param pos 出现位置
     * @param time 出现时间
     * @param type 提示类型
     * @param body  出现的物体
     */
    public setTip(obj, data, type) {
        let tip: TipMask = self.getTip();    

        tip.setShowData(data.pos, data.time, type);        

        if(type == Const.ballID){
            this.scheduleOnce(() => {                
                Global.playMusic("shot");
                let body:cc.RigidBody = obj.getComponent(cc.RigidBody);
                body.linearVelocity = cc.v2(data.power[0], data.power[1]);
                body.angularVelocity = -810;
                body.linearDamping = -0.5;
                body.gravityScale = 1;
            }, data.time)
        }
        else if(type == Const.boomID){
            this.scheduleOnce(() => {         
                Global.playMusic("shot");             
                let body = obj.getComponent(cc.RigidBody);
                body.linearVelocity = cc.v2(data.power[0], data.power[1]);
                body.angularVelocity = 300;
                body.linearDamping = -0.5;
                body.gravityScale = 1;

                let boom = body.getComponent(Boom);
                boom.openTimer();
            }, data.time)
        }
    }

    private getTip() {
        for (let i = 0; i < self.tipArray.length; i++) {
            if (!self.tipArray[i].active) {
                return self.tipArray[i].getComponent(TipMask);
            }
        }
    }

}
