const {ccclass, property} = cc._decorator;

let self:TipScore
@ccclass
export default class TipScore extends cc.Component {

    private tipScore = [];
    private prizeScore = [];

    onLoad(){
        self = this;
        self.tipScore = self.node.getChildByName("tipScore").children;
        self.prizeScore = self.node.getChildByName("prizeScore").children;

        cc.director.on("addScore", self.showTip);
    }

    private showTip(data){
        var data = data.getUserData();
        var score = data.score;
        var pos = data.pos;        
        
        let tipScore;        

        if(data.type == 1){
            tipScore = self.getTip(1);
            if(data.dir == 1){
                pos.x += 25;
                pos.y -= 25; 
            }       
            else{
                pos.x -= 25;
                pos.y -= 25; 
            }
        }
        else if(data.type == 2){
            tipScore = self.getTip(2);  
            if(data.dir == 1){
                pos.x += 25;                 
            }       
            else{    
                pos.x -= 25;                             
            }  
            pos.y += 50;
        }            
        tipScore.setPosition(pos);        
        tipScore.getComponent(cc.Label).string = "+" + score;        

        tipScore.runAction(cc.sequence(
            cc.moveBy(0.3, 0, 25),
            cc.fadeOut(0.2)
        ))
    }

    private getTip(type){
        if(type == 1){
            for(let i = 0; i < self.tipScore.length; i++){
                if(self.tipScore[i].opacity == 0){                                
                    self.tipScore[i].opacity = 255;
                    return self.tipScore[i];
                }
            }
        }
        else if(type == 2){
            for(let i = 0; i < self.prizeScore.length; i++){
                if(self.prizeScore[i].opacity == 0){                                
                    self.prizeScore[i].opacity = 255;
                    return self.prizeScore[i];
                }
            }
        }
    }

}
