const { ccclass, property } = cc._decorator;


let self: GameTip
@ccclass
export default class GameTip extends cc.Component {
    private tip_finger: cc.Node;
    private hideCallBack = null;
    private hideAction = null;

    onLoad() {
        self = this;
        self.tip_finger = self.node.getChildByName("tip_finger");
        self.addEvent();
    }

    start(){
        var callBack = cc.callFunc(() => {
            self.tip_finger.setPosition(166, -8);
        });

        self.hideCallBack = cc.callFunc(() => {
            self.node.active = false;
        })

        self.tip_finger.runAction(cc.repeatForever(
            cc.sequence(
                cc.moveTo(1, -80, -130).easing(cc.easeInOut(1)),
                cc.fadeOut(0.3),
                callBack,
                cc.fadeIn(0.1)
            )
        ))

        self.hideAction = cc.sequence(
            cc.fadeOut(0.3),
            self.hideCallBack
        )
    }

    private addEvent() {
        cc.director.on("hideGamehall", self.hideMy, self);
    }

    onEnable() {

    }

    onDisable(){
        this.node.opacity = 255;
    }

    private hideMy() {        
        self.node.runAction(self.hideAction)
    }

    public showMy() {      
        self.node.stopAction(self.hideAction);
        self.node.active = true;               
    }

}
