import { wxApply } from "./wxGame/wxApply";
import { Global } from "./Global";
import { Const } from "./Const";


const {ccclass, property} = cc._decorator;

let self: Rank;
@ccclass
export default class Rank extends cc.Component {
    private tex: cc.Texture2D;

    @property(cc.Sprite)
    private display: cc.Sprite = null;  
    
    ///|private rank:cc.Node;    

    @property(cc.Node)
    private spriteBg:cc.Node = null;

    @property(cc.Node)
    private bg:cc.Node = null;

    @property(cc.Node)
    private btn_share:cc.Node = null;

    @property(cc.Node)
    private btn_goHome:cc.Node = null;

    onLoad(){        
        self = this;                    
    }

    start () {             
        self.tex = new cc.Texture2D();      
                
        self.btn_share.on(cc.Node.EventType.TOUCH_END, self.share, self);        
        self.btn_goHome.on(cc.Node.EventType.TOUCH_END, self.closeMy, self);

        //self.onStage();
    }

    private friendRank(){
        let msg = {
            message: "friend",
            nickname: Global.USER_INFO.nickname          
        }
        wxApply.postMessage(msg); 
    }

    onDisable(){
        self.bg.active = false;
        self.btn_share.active = false;
        self.btn_goHome.active = false;
        self.display.spriteFrame = null;
        self.spriteBg.active = false;
    }

   /**
    * 
    * @param type 1.好友  2.下一位
    */
    public showMy(type){        
        if(type == 1){
            this.bg.active = true;
            this.btn_share.active = true;
            this.btn_goHome.active = true;
            this.spriteBg.active = true;
        }
        else{
            this.bg.active = false;
            this.btn_share.active = false;
            this.btn_goHome.active = false;
            this.spriteBg.active = false;
        }
        this.node.active = true;
    }

    public share(){
        wxApply.shareAppMessage(1);
    }
    

    public closeMy(){               
        let msg = {
            message: "close",
            type:"all"                          
        }
        wxApply.postMessage(msg);         
        this.node.active = false;        
        //Global.destroyBanner();
    }

    update() {
        //self._updaetSubDomainCanvas();
    }    

    private _updaetSubDomainCanvas() {
        if (!self.tex) {
            return;
        }        
        self.tex.initWithElement(sharedCanvas);
        self.tex.handleLoadedTexture();
        self.display.spriteFrame = new cc.SpriteFrame(self.tex);        
    }     
}
