const { ccclass, property } = cc._decorator;


@ccclass
export default class Toast extends cc.Component {
    private myLable: cc.Label;
    private callBack;

    onLoad() {
        this.myLable = this.getComponent(cc.Label);

        this.callBack = cc.callFunc(()=>{
            this.node.active = false
        }, this);
    }

    onEnable() {
        this.node.setPosition(0,0);
        this.node.runAction(cc.sequence(
            cc.spawn(
                cc.moveBy(1, 0, 20),  
                cc.fadeOut(1)
            ),
            this.callBack
        ))
    }

    onDisable(){
        this.node.opacity = 255;
    }

    public setLable(str){
        this.myLable.string = str;
    }

}
